Index: doc/bibliography/pl.bib
===================================================================
--- doc/bibliography/pl.bib	(revision b51b2a66357efaa480b18720757dd93f78c38e23)
+++ doc/bibliography/pl.bib	(revision 795500c3356351d89c5e43fce1d39d3cd33f48b1)
@@ -230,15 +230,4 @@
     publisher	= {MIT Press, Cambridge},
     year	= 1986
-}
-
-@inproceedings{Srinivasan08,
-    author	= {Srinivasan, Sriram and Mycroft, Alan},
-    editor	= {Vitek, Jan},
-    title	= {Kilim: Isolation-Typed Actors for Java},
-    organization= {ECOOP 2008 -- Object-Oriented Programming},
-    year	= {2008},
-    publisher	= {Springer Berlin Heidelberg},
-    address	= {Berlin, Heidelberg},
-    pages	= {104--128},
 }
 
@@ -430,4 +419,18 @@
 }
 
+@article{Delisle21,
+    keywords	= {concurrency, Cforall},
+    contributer	= {pabuhr@plg},
+    author	= {Thierry Delisle and Peter A. Buhr},
+    title	= {Advanced Control-flow and Concurrency in \textsf{C}$\mathbf{\forall}$},
+    journal	= spe,
+    month	= may,
+    year	= 2021,
+    volume	= 51,
+    number	= 5,
+    pages	= {1005-1042},
+    optnote	= {\href{https://onlinelibrary.wiley.com/doi/10.1002/spe.2925}{https://\-onlinelibrary.wiley.com/\-doi/\-10.1002/\-spe.2925}},
+}
+
 @article{Buhr00a,
     keywords	= {exception handling},
@@ -1226,4 +1229,15 @@
 }
 
+@phdthesis{Delisle22,
+    contributer	= {pabuhr@plg},
+    author	= {Delisle, Thierry},
+    title	= {The \textsf{C}$\mathbf{\forall}$ Scheduler},
+    school	= {School of Computer Science, University of Waterloo},
+    address	= {Waterloo, Ontario, Canada, N2L 3G1},
+    publisher	= {UWSpace},
+    year	= 2022,
+    note	= {\url{http://hdl.handle.net/10012/18941}}
+}
+
 @misc{CFAStackEvaluation,
     contributer	= {a3moss@plg},
@@ -1643,5 +1657,6 @@
     volume	= 21,
     number	= 8,
-    pages	= {666-677}
+    pages	= {666-677},
+    publisher	= {ACM New York, NY, USA},
 }
 
@@ -1988,21 +2003,8 @@
     title	= {Concurrency in \textsf{C}$\mathbf{\forall}$},
     school	= {School of Computer Science, University of Waterloo},
+    address	= {Waterloo, Ontario, Canada, N2L 3G1},
+    publisher	= {UWSpace},
     year	= 2018,
-    optaddress	= {Waterloo, Ontario, Canada, N2L 3G1},
-    note	= {\href{https://uwspace.uwaterloo.ca/handle/10012/12888}{https://\-uwspace.uwaterloo.ca/\-handle/\-10012/\-12888}},
-}
-
-@article{Delisle21,
-    keywords	= {concurrency, Cforall},
-    contributer	= {pabuhr@plg},
-    author	= {Thierry Delisle and Peter A. Buhr},
-    title	= {Advanced Control-flow and Concurrency in \textsf{C}$\mathbf{\forall}$},
-    journal	= spe,
-    month	= may,
-    year	= 2021,
-    volume	= 51,
-    number	= 5,
-    pages	= {1005-1042},
-    optnote	= {\href{https://onlinelibrary.wiley.com/doi/10.1002/spe.2925}{https://\-onlinelibrary.wiley.com/\-doi/\-10.1002/\-spe.2925}},
+    note	= {\url{http://hdl.handle.net/10012/12888}},
 }
 
@@ -3345,4 +3347,15 @@
 }
 
+@mastersthesis{Beach21,
+    contributer	= {pabuhr@plg},
+    author	= {Beach, Andrew James},
+    title	= {Exception Handling in \textsf{C}$\mathbf{\forall}$},
+    school	= {School of Computer Science, University of Waterloo},
+    address	= {Waterloo, Ontario, Canada, N2L 3G1},
+    publisher	= {UWSpace},
+    year	= {2021},
+    note	= {\url{http://hdl.handle.net/10012/17617}},
+}
+
 @article{Liskov79,
     keywords	= {exception handling},
@@ -4076,5 +4089,5 @@
     year	= 2022,
     address	= {Waterloo, Ontario, Canada, N2L 3G1},
-    note	= {\href{https://uwspace.uwaterloo.ca/handle/10012/18329}{https://\-uwspace.uwaterloo.ca/\-handle/\-10012/18329}},
+    note	= {\url{http://hdl.handle.net/10012/18329}},
 }
 
@@ -4328,5 +4341,5 @@
     month	= sep,
     optaddress	= {Waterloo, Ontario, Canada, N2L 3G1},
-    note	= {\href{https://uwspace.uwaterloo.ca/handle/10012/13935}{https://\-uwspace.uwaterloo.ca/\-handle/\-10012/\-13935}},
+    note	= {\url{https://uwspace.uwaterloo.ca/handle/10012/13935}},
 }
 
@@ -4725,4 +4738,15 @@
     year	= 1996,
     pages	= {80-87},
+}
+
+@inproceedings{Srinivasan08,
+    author	= {Srinivasan, Sriram and Mycroft, Alan},
+    editor	= {Vitek, Jan},
+    title	= {Kilim: Isolation-Typed Actors for Java},
+    organization= {ECOOP 2008 -- Object-Oriented Programming},
+    year	= {2008},
+    publisher	= {Springer Berlin Heidelberg},
+    address	= {Berlin, Heidelberg},
+    pages	= {104--128},
 }
 
@@ -5078,4 +5102,24 @@
 }
 
+@article{Hesselink23,
+    keywords	= {Concurrency, mutual exclusion, atomicity, critical section, efficiency},
+    contributer	= {pabuhr@plg},
+    author	= {Hesselink, Wim H. and Buhr, Peter A.},
+    title	= {MCSH, a Lock with the Standard Interface},
+    issue_date	= {June 2023},
+    publisher	= {Association for Computing Machinery},
+    address	= {New York, NY, USA},
+    volume	= 10,
+    number	= 2,
+    journal	= {ACM Trans. Parallel Comput.},
+    issn	= {2329-4949},
+    url		= {https://doi.org/10.1145/3584696},
+    doi		= {10.1145/3584696},
+    articleno	= 11,
+    numpages	= 23,
+    month	= jun,
+    year	= {2023},
+}
+
 @inproceedings{mprof,
     keywords	= {malloc},